package controllers

import (
	"encoding/json"
	"fmt"
	"hongze/hongze_chart_lib/models"
	"hongze/hongze_chart_lib/utils"
	"net/http"
	"net/url"
	"github.com/beego/beego/v2/server/web"

	"github.com/rdlucklib/rdluck_tools/log"
)

var apiLog *log.Log

func init() {
	if utils.RunMode == "release" {
		logDir := `/data/rdlucklog/hongze_chart_lib`
		apiLog = log.Init("20060102.api", logDir)
	} else {
		apiLog = log.Init("20060102.api")
	}
}

type BaseAuthController struct {
	web.Controller
}

func (this *BaseAuthController) Prepare() {
	fmt.Println("enter prepare")
	method := this.Ctx.Input.Method()
	uri := this.Ctx.Input.URI()
	ip := this.Ctx.Input.IP()
	fmt.Println("Url:", uri+";ip:"+ip)
	if method != "HEAD" {
		if method == "POST" || method == "GET" {
			//authorization := this.Ctx.Input.Header("authorization")
			//if authorization == "" {
			//	authorization = this.Ctx.Input.Header("Authorization")
			//}
			//if authorization == "" {
			//	newAuthorization := this.GetString("authorization")
			//	account := this.GetString("account")
			//	authorization = "authorization=" + newAuthorization + ";account=" + account
			//	if newAuthorization == "" {
			//		newAuthorization = this.GetString("Authorization")
			//		if account == "" {
			//			account = this.GetString("Account")
			//		}
			//		authorization = "authorization=" + newAuthorization + ";account=" + account
			//	}
			//}
			//fmt.Println("authorization##################")
			//fmt.Println(authorization)
			//fmt.Println("authorization############")
			//if authorization == "" {
			//	strArr := strings.Split(uri, "?")
			//	for k, v := range strArr {
			//		fmt.Println(k, v)
			//	}
			//	if len(strArr) > 1 {
			//		authorization := strArr[1]
			//		authorization = strings.Replace(authorization, "Authorization", "authorization", -1)
			//		fmt.Println(authorization)
			//	}
			//}
			//fmt.Println("authorization------------")
			//fmt.Println(authorization)
			//fmt.Println("authorization-------------")
			//if authorization == "" {
			//	this.JSON(models.BaseResponse{Ret: 408, Msg: "请重新授权！", ErrMsg: "请重新授权:Token is empty or account is empty"}, false, false)
			//	this.StopRun()
			//	return
			//}
			//authorizationArr := strings.Split(authorization, ";")
			//tokenStr := authorizationArr[0]
			//tokenArr := strings.Split(tokenStr, "=")
			//token := tokenArr[1]
			//
			//accountStr := authorizationArr[1]
			//accountArr := strings.Split(accountStr, "=")
			//account := accountArr[1]
			//
			//fmt.Println("token:", token)
			//fmt.Println("account:", account)
			////校验token是否合法
			//// JWT校验Token和Account
			//if !utils.CheckToken(account, token) {
			//	fmt.Println("CheckToken Err")
			//	this.JSON(models.BaseResponse{Ret: 408, Msg: "鉴权失败，请重新登录！", ErrMsg: "登录失效，请重新登陆!,CheckToken Fail"}, false, false)
			//	this.StopRun()
			//	return
			//}
			//
			//fmt.Println("GetUserByToken")
			//session, err := system.GetSysSessionByToken(token)
			//if err != nil {
			//	if err.Error() == utils.ErrNoRow() {
			//		this.JSON(models.BaseResponse{Ret: 408, Msg: "信息已变更,请重新登陆！", ErrMsg: "Token 信息已变更:Token: " + token}, false, false)
			//		this.StopRun()
			//		return
			//	}
			//	this.JSON(models.BaseResponse{Ret: 408, Msg: "网络异常，请稍后重试!", ErrMsg: "获取用户信息异常，Eerr:" + err.Error()}, false, false)
			//	this.StopRun()
			//	return
			//}
			//if session == nil {
			//	this.JSON(models.BaseResponse{Ret: 408, Msg: "网络异常，请稍后重试!", ErrMsg: "sesson is empty "}, false, false)
			//	this.StopRun()
			//	return
			//}
			//if time.Now().After(session.ExpiredTime) {
			//	this.JSON(models.BaseResponse{Ret: 408, Msg: "请重新登录!", ErrMsg: "获取用户信息异常，Eerr:" + err.Error()}, false, false)
			//	this.StopRun()
			//	return
			//}
			//admin, err := system.GetSysUserById(session.SysUserId)
			//if err != nil {
			//	if err.Error() == utils.ErrNoRow() {
			//		this.JSON(models.BaseResponse{Ret: 408, Msg: "信息已变更,请重新登陆！", ErrMsg: "获取admin 信息失败 " + strconv.Itoa(session.SysUserId)}, false, false)
			//		this.StopRun()
			//		return
			//	}
			//	this.JSON(models.BaseResponse{Ret: 408, Msg: "网络异常，请稍后重试!", ErrMsg: "获取admin信息异常，Eerr:" + err.Error()}, false, false)
			//	this.StopRun()
			//	return
			//}
			//if admin == nil {
			//	this.JSON(models.BaseResponse{Ret: 408, Msg: "网络异常，请稍后重试!", ErrMsg: "admin is empty "}, false, false)
			//	this.StopRun()
			//	return
			//}
			//admin.RoleTypeCode = GetSysUserRoleTypeCode(admin.RoleTypeCode)
			//this.SysUser = admin
		} else {
			this.JSON(models.BaseResponse{Ret: 408, Msg: "请求异常，请联系客服!", ErrMsg: "POST之外的请求，暂不支持"}, false, false)
			this.StopRun()
			return
		}
	}
}

func (c *BaseAuthController) ServeJSON(encoding ...bool) {
	var (
		hasIndent   = false
		hasEncoding = false
	)
	if web.BConfig.RunMode == web.PROD {
		hasIndent = false
	}
	if len(encoding) > 0 && encoding[0] == true {
		hasEncoding = true
	}
	if c.Data["json"] == nil {
		go utils.SendEmail("异常提醒:", "接口:"+"URI:"+c.Ctx.Input.URI()+";无返回值", utils.EmailSendToUsers)
		return
	}
	baseRes := c.Data["json"].(*models.BaseResponse)
	if baseRes != nil && baseRes.Ret != 200 && baseRes.Ret != 408 && baseRes.IsSendEmail {
		body, _ := json.Marshal(baseRes)
		var requestBody string
		method := c.Ctx.Input.Method()
		if method == "GET" {
			requestBody = c.Ctx.Request.RequestURI
		} else {
			requestBody, _ = url.QueryUnescape(string(c.Ctx.Input.RequestBody))
		}
		go utils.SendEmail(utils.APPNAME+"【"+utils.RunMode+"】"+"失败提醒", "URI:"+c.Ctx.Input.URI()+"<br/> "+"Params"+requestBody+" <br/>"+"ErrMsg:"+baseRes.ErrMsg+";<br/>Msg:"+baseRes.Msg+";<br/> Body:"+string(body)+"<br/>", utils.EmailSendToUsers)
	}
	c.JSON(c.Data["json"], hasIndent, hasEncoding)
}

func (c *BaseAuthController) JSON(data interface{}, hasIndent bool, coding bool) error {
	c.Ctx.Output.Header("Content-Type", "application/json; charset=utf-8")
	var content []byte
	var err error
	if hasIndent {
		content, err = json.MarshalIndent(data, "", "  ")
	} else {
		content, err = json.Marshal(data)
	}
	if err != nil {
		http.Error(c.Ctx.Output.Context.ResponseWriter, err.Error(), http.StatusInternalServerError)
		return err
	}
	ip := c.Ctx.Input.IP()
	requestBody, err := url.QueryUnescape(string(c.Ctx.Input.RequestBody))
	if err != nil {
		requestBody = string(c.Ctx.Input.RequestBody)
	}
	if requestBody == "" {
		requestBody = c.Ctx.Input.URI()
	}
	apiLog.Println("请求地址：", c.Ctx.Input.URI(), "Authorization:", c.Ctx.Input.Header("Authorization"), "RequestBody：", requestBody, "ResponseBody", string(content), "IP：", ip)
	if coding {
		content = []byte(utils.StringsToJSON(string(content)))
	}
	return c.Ctx.Output.Body(content)
}
