package response

import (
	"hongze/hongze_admin/models/data_manage"
	"hongze/hongze_admin/models/data_manage/line_equation/request"
)

type ChartInfoResp struct {
	List []ChartDataResp `description:"数据列表"`
}

// ChartDataResp 图表数据
type ChartDataResp struct {
	LatestDate          string  `description:"真实数据的日期"`
	Name                string  `description:"名称"`
	NameEn              string  `description:"英文名称"`
	EdbInfoCategoryType int     `description:"普通数据还是预测数据，0：普通，1：预测"`
	MaxData             float64 `description:"最大值"`
	MinData             float64 `description:"最小值"`
	DataList            []data_manage.EdbDataList
}

// MultipleGraphConfigDetailResp 配置详情接口返回
type MultipleGraphConfigDetailResp struct {
	MultipleGraphConfigId int
	LineChartInfoConfig   request.LineChartInfoReq
	EdbInfoList           []*data_manage.ChartEdbInfoMapping
	ChartMappingList      []MultipleGraphConfigChartMapping `description:"关联图表"`
}
type MultipleGraphConfigChartMapping struct {
	ChartInfoId int `description:"图表id"`
	Source      int `description:"来源,5:斜率图，6：截距图；7：相关性图；"`
}
type MultipleGraphConfigEdbMapping struct {
	EdbInfoId int `description:"图表id"`
	Source    int `description:"来源,5:斜率图，6：截距图；7：相关性图；"`
}
