package models

import (
	_ "github.com/go-sql-driver/mysql"
	"hongze/hongze_chart_lib/models/data_manage"
	"hongze/hongze_chart_lib/models/data_manage/future_good"
	"hongze/hongze_chart_lib/utils"
	"time"

	"github.com/beego/beego/v2/client/orm"
)

func init() {

	_ = orm.RegisterDataBase("default", "mysql", utils.MYSQL_URL)
	orm.SetMaxIdleConns("default", 50)
	orm.SetMaxOpenConns("default", 100)

	db, _ := orm.GetDB("default")
	db.SetConnMaxLifetime(10 * time.Minute)

	_ = orm.RegisterDataBase("data", "mysql", utils.MYSQL_URL_DATA)
	orm.SetMaxIdleConns("data", 50)
	orm.SetMaxOpenConns("data", 100)

	data_db, _ := orm.GetDB("data")
	data_db.SetConnMaxLifetime(10 * time.Minute)

	_ = orm.RegisterDataBase("edb", "mysql", utils.MYSQL_URL_EDB)
	orm.SetMaxIdleConns("edb", 50)
	orm.SetMaxOpenConns("edb", 100)

	edb_db, _ := orm.GetDB("edb")
	edb_db.SetConnMaxLifetime(10 * time.Minute)

	orm.Debug = true
	orm.DebugLog = orm.NewLog(utils.Binlog)

	//注册对象
	orm.RegisterModel(
		new(data_manage.EdbInfo),
		new(ShareChartRefreshLog),                       //分享图表刷新日志表
		new(ExcelInfo),                                  //excel表格
		new(data_manage.PredictEdbConf),                 //预测指标配置
		new(data_manage.PredictEdbRuleData),             //预测指标配置生成的数据
		new(data_manage.PredictEdbConfCalculateMapping), //预测指标关系表
		new(data_manage.ChartInfoCorrelation),           // 图表相关性信息
	)
	// 期货数据库
	initFutureGood()
}

// initFutureGood 注册期货数据 数据表
func initFutureGood() {
	//注册对象
	orm.RegisterModel(
		new(future_good.FutureGoodEdbInfo),         //期货指标表
		new(future_good.FutureGoodEdbData),         //期货指标数据表
		new(future_good.ChartInfoFutureGoodProfit), //期货利润图的扩展表
	)
}
