package utils

import (
	"fmt"
	beeLogger "github.com/beego/bee/v2/logger"
	"github.com/beego/beego/v2/server/web"
	"github.com/rdlucklib/rdluck_tools/cache"
)

var (
	RunMode        string //运行模式
	MYSQL_URL      string //数据库连接
	MYSQL_URL_DATA string
	MYSQL_URL_EDB         string

	REDIS_CACHE string       //缓存地址
	Rc          *cache.Cache //redis缓存
	Re          error        //redis错误
)

// 经济数据库
var (
	EDB_LIB_URL string
)

func init() {
	tmpRunMode, err := web.AppConfig.String("run_mode")
	if err != nil {
		panic("配置文件读取run_mode错误 " + err.Error())
	}
	RunMode = tmpRunMode
	if RunMode == "" {
		RunMode = "release"
		configPath := `/home/code/config/hongze_chart_lib/conf/app.conf`
		err := web.LoadAppConfig("ini", configPath)
		if err != nil {
			fmt.Println("web.LoadAppConfig Err:" + err.Error())
		}
	}
	config, err := web.AppConfig.GetSection(RunMode)
	if err != nil {
		panic("配置文件读取错误 " + err.Error())
	}
	beeLogger.Log.Info(RunMode + " 模式")
	MYSQL_URL = config["mysql_url"]

	MYSQL_URL_DATA = config["mysql_url_data"]
	MYSQL_URL_EDB = config["mysql_url_edb"]

	REDIS_CACHE = config["beego_cache"]
	if len(REDIS_CACHE) <= 0 {
		panic("redis链接参数没有配置")
	}

	Rc, Re = cache.NewCache(REDIS_CACHE) //初始化缓存
	if Re != nil {
		fmt.Println(Re)
		panic(Re)
	}

	if RunMode == "release" {

		//同花顺，万得接口服务地址（阿里云windows服务器地址；内网地址）
		Hz_Server_Data_Url = "http://172.19.173.231:7000/"

		EDB_LIB_URL = "http://172.19.173.232:8300/edbapi/"
	} else {
		//同花顺，万得接口服务地址（阿里云windows服务器地址；外网地址）
		Hz_Server_Data_Url = "http://139.196.136.213:7000/"

		EDB_LIB_URL = "http://8.136.199.33:8300/edbapi/"
	}
}


//http://8.136.199.33:8608/swagger/
//http://8.136.199.33:8608/v1